#ifndef F_CPU
#define F_CPU 8000000UL
#endif

#include <avr/io.h>
#include <util/delay.h>
#include "spi.h"
#include "mcp.h"


int main(void)
{
	spi_init();
	mcp_init(MCP_SEQOP | MCP_HAEN);
	
	// MCP23S17, HWADDR = 0x00
	mcp_write_byte(0, MCP_IODIR | MCP_PORTA, 0xFF);	// Input
	mcp_write_byte(0, MCP_GPPU	| MCP_PORTA, 0xFF);	// Activate PullUps
	mcp_write_byte(0, MCP_GPIO	| MCP_PORTB, 0x00);	// Output
	
	// MCP23S17, HWADDR = 0x01
	mcp_write_byte(1, MCP_GPIO	| MCP_PORTA, 0x00);	// Output
	mcp_write_byte(1, MCP_GPIO	| MCP_PORTB, 0x00);	// Output
	
	while (1) 
    {
		uint8_t readSwitch = mcp_read_byte(0, MCP_GPIO | MCP_PORTA);
		mcp_write_byte(0, MCP_GPIO | MCP_PORTB, readSwitch);
		
		static uint8_t ct = 0;
		mcp_write_byte(1, MCP_GPIO | MCP_PORTA, (1<<ct));
		mcp_write_byte(1, MCP_GPIO | MCP_PORTB, (1<<(7-ct)));		
		if(++ct == 8) ct = 0;
		_delay_ms(50);
    }
}

