#include "mcp.h"

void mcp_init(uint8_t data)
{
	MCP_DDR |= (1<<MCP_CS);
	MCP_PORT |= (1<<MCP_CS);
	mcp_write_byte(0, MCP_IOCON, data);
}

void mcp_write_byte(uint8_t addr, uint8_t reg, uint8_t data)
{
	MCP_PORT &= ~(1<<MCP_CS);
	spi_transfer(MCP_OPCODE | ((addr<<1) & 0x0e)  | MCP_WRITE);
	spi_transfer(reg);
	spi_transfer(data);
	MCP_PORT |= (1<<MCP_CS);
}

void mcp_write_bit(uint8_t addr, uint8_t reg, uint8_t bit, uint8_t data)
{
	uint8_t recData = mcp_read_byte(addr, reg);
	if(data) recData |= (1<<bit);
	else recData &= ~(1<<bit);
	mcp_write_byte(addr, reg, recData);
}

uint8_t mcp_read_byte(uint8_t addr, uint8_t reg)
{
	uint8_t recData = 0;
	MCP_PORT &= ~(1<<MCP_CS);
	spi_transfer(MCP_OPCODE | ((addr << 1) & 0x0e) | MCP_READ);
	spi_transfer(reg);
	recData = spi_transfer(0x00);
	MCP_PORT |= (1<<MCP_CS);
	return recData;
}

uint8_t mcp_read_bit(uint8_t addr, uint8_t reg, uint8_t bit)
{
	uint8_t recData = mcp_read_byte(addr, reg);
	if(recData & (1<<bit)) return 1;
	else return 0;
}